/*----------------------------------------------------------------------
    Node control
	Created  by H.TSUKATA      1995
	Modified by H.Goto     Sep 1997
	Modified by H.Goto     Jul 2003
----------------------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1994-2003  Hitoshi TSUKATA and Hideaki GOTO

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the authors' names, Hitoshi TSUKATA and Hideaki GOTO, may not be
  used in any advertising or otherwise to promote the sale, use or
  other dealings in this software without prior written authorization
  from the authors, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of modification is specified in cases
  where modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/

#ifndef _NODE_H_
#define _NODE_H_

#include <stdio.h>

// for C++ STL
#include <list>


template <class T>
class NODE {
public:
  int			nd_vflg;	// õ Ƚե饰
  std::list<T>		nd_adj_node;	// ܥΡɥꥹ
  virtual int	nd_visit_check( T)=0;

  NODE(){ nd_vflg=0; nd_adj_node.clear(); }
  virtual ~NODE(){} 

#if 0
  int nd_tansaku( std::list<T> & lst){
	/**  ͥõ **/
	std::list<T>	tl;
	int		ret;
	T		r;
	if( nd_vflg!=0) return(0) ;	// õѤɤ Ƚ
	nd_vflg =1;
	lst.push_back( ((T)this));
	
	for( tl=nd_adj_node,ret=1; ! tl.empty() ; tl.pop_front()){
	  r = tl.front();
	  if( nd_visit_check( r))
		ret += r->nd_tansaku( lst);
	}
	return( ret);
  }
#endif
};


#endif	/* _NODE_H_ */
